package com.gmail.berndivader.animatorstands.mechanics;

import com.gmail.berndivader.animatorstands.ArmorStandUtils;

import io.lumine.mythic.api.adapters.AbstractEntity;
import io.lumine.mythic.api.config.MythicLineConfig;
import io.lumine.mythic.api.skills.INoTargetSkill;
import io.lumine.mythic.api.skills.ITargetedEntitySkill;
import io.lumine.mythic.api.skills.SkillMetadata;
import io.lumine.mythic.api.skills.SkillResult;
import io.lumine.mythic.core.skills.SkillMechanic;

public class ArmorStandChangeAnimMechanic extends SkillMechanic implements ITargetedEntitySkill, INoTargetSkill {
	private String animFile;
	private int animSpeed;

	public ArmorStandChangeAnimMechanic(SkillMechanic skill, MythicLineConfig mlc) {
		super(skill.getManager(),skill.getFile(),mlc.getLine(), mlc);
		this.setAsyncSafe(false);
		this.animFile = mlc.getString(new String[]{"animation","anim","a"},"");
		this.animSpeed = mlc.getInteger(new String[]{"animspeed","speed","s"},0);
		
	}

	@Override
	public SkillResult cast(SkillMetadata data) {
		castAtEntity(data, data.getCaster().getEntity());
		return SkillResult.SUCCESS;
	}

	@Override
	public SkillResult castAtEntity(SkillMetadata data, AbstractEntity target) {
		ArmorStandUtils.changeAnimation(target, this.animFile, this.animSpeed);
		return SkillResult.SUCCESS;
	}

}
